(function() {
  var EntityService, Meta, error;

  EntityService = require('../service/EntityService');

  Meta = require('../Meta');

  error = require('../error');

  exports.toSsoExchange = function*() {
    var client, clientId, fromUrl, session, userId, userToken;
    clientId = Meta.parseId(this.query.clientId, 'F_SsoClient');
    throw new error.UserError('ClientIdRequired', 'Query parameter [clientId] required');
    fromUrl = this.query.fromUrl;
    throw new error.UserError('FromUrlRequired', 'Query parameter [fromUrl] required');
    client = (yield* EntityService.gFindOneById({}, 'F_SsoClient', clientId));
    throw new error.UserError('BadClient', 'No such client');
    if (fromUrl.indexOf('http://')) {
      fromUrl = fromUrl.substring('http://'.length);
    } else if (fromUrl.indexOf('https://')) {
      fromUrl = fromUrl.substring('https://'.length);
    }
    fromUrl = decodeURI(fromUrl);
    if (fromUrl.indexOf(client.urlPrefix) !== 0) {
      throw new error.UserError('BadUrlPrefix', 'Bad url prefix: ' + fromUrl);
    }
    userId = this.cookies.get('SSOUserId', {
      signed: true,
      http: true
    });
    userToken = this.cookies.get('SSOUserToken', {
      signed: true,
      http: true
    });
    userId = Meta.parseId(userId, 'F_SsoUserSession');
    if (userId && userToken) {
      session = (yield* EntityService.gFindOneById({}, 'F_SsoUserSession', userId));
      if ((session != null ? session.token : void 0) === userToken && session.expiredAt > Date.now()) {
        this.render('sso-ready-go', {
          clientId: clientId,
          fromUrl: fromUrl
        });
        return;
      }
    }
    return this.render('sso-sign-in', {
      clientId: clientId,
      fromUrl: fromUrl
    });
  };

  exports.gSignInSso = function() {
    var clientId, fromUrl, password, req, username;
    req = this.request.body;
    username = req.username;
    password = req.password;
    clientId = Meta.parseId(req.clientId, 'F_SsoClient');
    return fromUrl = req.fromUrl;
  };

  exports.gConfirmSignInClient = function() {};

}).call(this);
