(function() {
  var config;

  config = require('./config');

  exports.use = function(f) {
    var cluster, i, j, ref, results, workerNum;
    if (!config.cluster) {
      return f();
    } else {
      cluster = require('cluster');
      workerNum = config.workerNum;
      if (cluster.isMaster) {
        console.log("Master " + process.pid + " is running");
        cluster.on('exit', function(worker, code, signal) {
          return console.log("worker " + worker.process.pid + " died");
        });
        results = [];
        for (i = j = 0, ref = workerNum; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
          results.push(cluster.fork());
        }
        return results;
      } else {
        console.log("Start Worker " + process.pid + " started");
        return f();
      }
    }
  };

}).call(this);
