(function() {
  var util;

  util = require('../util');

  exports.permissionArrayToMap = function(acl) {
    var e, entities, entityName, field, fieldName, results, v;
    if (acl == null) {
      return acl;
    }
    acl.menu = util.arrayToTrueObject(acl.menu);
    acl.button = util.arrayToTrueObject(acl.button);
    acl.action = util.arrayToTrueObject(acl.action);
    if (acl.entity) {
      entities = acl.entity;
      for (entityName in entities) {
        v = entities[entityName];
        entities[entityName] = util.arrayToTrueObject(v);
      }
    }
    if (acl.field) {
      entities = acl.field;
      results = [];
      for (entityName in entities) {
        e = entities[entityName];
        results.push((function() {
          var results1;
          results1 = [];
          for (fieldName in e) {
            field = e[fieldName];
            if (field) {
              results1.push(e[fieldName] = util.arrayToTrueObject(field));
            } else {
              results1.push(void 0);
            }
          }
          return results1;
        })());
      }
      return results;
    }
  };

}).call(this);
